extern char *malloc(), *realloc();

# line 2 "parse.y"
typedef struct IDLattr_name_tag 
{
  int linenumber,charpos;
  char *name;
} IDLATTR_NAME;


IDLVALUE IDLanIDLVALUE;
nodeDesc IDLanodeDesc;

/* returned by IDLVALUE */
/* attributes whose values are references are changed into
   string values and appended on IDLattrlabelrefs.

   set (and seq) elements that are references are changed into
   IDLnode values with a node name of IDLref_indicator_name
*/
typedef struct
{
  int isname;		/* boolean */
  union { IDLVALUE value;
	  String name; } value;
} IDLnewIDLVALUE;

/* data stack size */
#define YYMAXDEPTH 50000

unsigned int IDLlinechartemp1,IDLlinechartemp2;
/*#define IDLLINECHARPOS(linenum,charpos) \
  (((IDLlinechartemp1=(linenum<<12)) >= 1048575 ? 1048575 : IDLlinechartemp1) |\
   ((IDLlinechartemp2=(charpos&0xfff)) >= 4095 ? 4095 : IDLlinechartemp2))
*/
#define IDLLINECHARPOS(linenum,charpos) \
  ((((IDLlinechartemp1=linenum)>=0xfffff)?0xfffff:IDLlinechartemp1)<<12 |\
   (((IDLlinechartemp2=charpos)>=0xfff)?0xfff:IDLlinechartemp2))

#ifdef DEBUG
#define IDLReduce(lhs)	(void)fprintf(stderr, "Reduce to %s\n", lhs)
#else
#define IDLReduce(lhs)
#endif

# line 45 "parse.y"
typedef union {
String	     	name;
stringDesc   	strval;
booleanDesc  	boolval;
rationalDesc 	ratval;
integerDesc  	intval;
nodeDesc     	VnodeDesc;
SEQattrDesc  	VSEQattrDesc;
attrDesc     	VattrDesc;
IDLnewIDLVALUE	VIDLVALUE;
setDesc		VsetDesc;
sequenceDesc	VsequenceDesc;
SEQIDLVALUE	VSEQIDLVALUE;
IDLATTR_NAME    *attr_name_type;
} YYSTYPE;
# define IDLLPAREN 257
# define IDLRPAREN 258
# define IDLLBRACKET 259
# define IDLRBRACKET 260
# define IDLLBRACE 261
# define IDLRBRACE 262
# define IDLLESS 263
# define IDLGREATER 264
# define IDLSEMICOLON 265
# define IDLEND 266
# define IDLSTRING 267
# define IDLRATIONAL 268
# define IDLINTEGER 269
# define IDLBOOLEAN 270
# define IDLNAME 271
# define IDLLABELREF 272
# define IDLLABEL 273
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
YYSTYPE yylval, yyval;
# define YYERRCODE 256

# line 338 "parse.y"

static 
IDLmatch_references()
{
	SEQattrDesc 	Sad;
	attrDesc    	AnattrDesc;
	SEQIDLVALUE 	new_sequence, new_set;
    	IDLVALUE    	anewIDLVALUE;
    	IDLVALUE    	AnIDLVALUE, ASetIDLVALUE, ASeqIDLVALUE;
	SEQIDLVALUE 	SSEQIDLVALUE, SIDLVALUE;
	nodeDesc    	found;
	nodeDesc    	IDLfind_label();

				/* resolve labels as attribute values */
	foreachinSEQattrDesc(IDLattrlabelrefs, Sad, AnattrDesc) {
	  if (found=IDLfind_label(AnattrDesc->value.VstringDesc->value)) {
	    AnattrDesc->value.VnodeDesc = found;
	  }
	  else {
	    (void)fprintf(stderr, "no matching node for label %s\n",
		    AnattrDesc->value.VstringDesc->value);
	  }
	}

				/* resolve labels in sets */
				/* assume that sets contain no duplicates */
	foreachinSEQIDLVALUE(IDLsetlabelrefs, SIDLVALUE, ASetIDLVALUE) {
	  initializeSEQIDLVALUE(new_set);
	  foreachinSEQIDLVALUE(ASetIDLVALUE.VsetDesc->value, SSEQIDLVALUE, AnIDLVALUE) {
	    if (typeof(AnIDLVALUE)==KnodeDesc) {
	      if (AnIDLVALUE.VnodeDesc->name == IDLref_indicator_name) {
				/* found a reference */
		if (found=IDLfind_label(AnIDLVALUE.VnodeDesc->label)) {
		  anewIDLVALUE.VnodeDesc = found;
		  appendrearSEQIDLVALUE(new_set, anewIDLVALUE);
		}
		else {
		  (void)fprintf(stderr, "no matching node for label %s\n",
			  AnIDLVALUE.VnodeDesc->label);
		}
	      }
	      else appendrearSEQIDLVALUE(new_set, AnIDLVALUE);
	    }
	    else appendrearSEQIDLVALUE(new_set, AnIDLVALUE);
	  }
/*	  foreachinSEQIDLVALUE(ASetIDLVALUE.VsetDesc->value, SSEQIDLVALUE, AnIDLVALUE) {
	    removeSEQIDLVALUE(ASetIDLVALUE.VsetDesc->value, AnIDLVALUE);
	  }
*/
	  ASetIDLVALUE.VsetDesc->value = new_set;
	  }

				/* resolve labels in sequences */
	foreachinSEQIDLVALUE(IDLseqlabelrefs, SIDLVALUE, ASeqIDLVALUE) {
	  initializeSEQIDLVALUE(new_sequence);
	  foreachinSEQIDLVALUE(ASeqIDLVALUE.VsequenceDesc->value, SSEQIDLVALUE, AnIDLVALUE) {
	    if (typeof(AnIDLVALUE)==KnodeDesc) {
	      if (AnIDLVALUE.VnodeDesc->name == IDLref_indicator_name) {
				/* found a reference */
		if (found=IDLfind_label(AnIDLVALUE.VnodeDesc->label)) {
		  anewIDLVALUE.VnodeDesc = found;
		    appendrearSEQIDLVALUE(new_sequence, anewIDLVALUE);
		}
		else {
		  (void)fprintf(stderr, "no matching node for label %s\n",
			  AnIDLVALUE.VnodeDesc->label);
		}
	      }
	      else appendrearSEQIDLVALUE(new_sequence, AnIDLVALUE);
	    }
	    else appendrearSEQIDLVALUE(new_sequence, AnIDLVALUE);
	  }
/*	  foreachinSEQIDLVALUE(ASeqIDLVALUE.VsetDesc->value, SSEQIDLVALUE, AnIDLVALUE) {
	    removeSEQIDLVALUE(ASeqIDLVALUE.VsequenceDesc->value, AnIDLVALUE);
	  }
*/
	  ASeqIDLVALUE.VsequenceDesc->value = new_sequence;
	}
}

yyerror(s)
char *s;
{
	if (!strcmp (s,"yacc stack overflow"))
	  (void)sprintf (IDLreaderror,"IDLread: parser stack overflow on line %-d: Increase YYMAXDEPTH in IDLread.c\n",s,IDLlineNumber);
	else
	  (void)sprintf (IDLreaderror,"IDLread: %s on line %-d\n",s,IDLlineNumber);
	(void)fputs (IDLreaderror,stderr);
        (void)fflush (stderr);
}
int yyexca[] ={
-1, 0,
	271, 32,
	-2, 2,
-1, 1,
	0, -1,
	-2, 0,
	};
# define YYNPROD 33
# define YYLAST 67
int yyact[]={

    29,    33,    30,    40,     5,    31,    24,    22,    21,    23,
    10,    28,     5,    29,    38,    30,    17,     5,     9,    24,
    22,    21,    23,     8,    28,     5,    29,    15,    30,    20,
     6,    13,    24,    22,    21,    23,    18,    28,     5,    14,
     7,    19,    17,    27,     2,     1,    16,    34,    36,    26,
    25,    11,    12,     4,     3,     0,     0,     0,     0,    32,
    35,    37,     0,     0,    39,     0,    41 };
int yypact[]={

  -269, -1000, -1000,  -236,  -253, -1000, -1000,  -256,  -229, -1000,
 -1000, -1000,  -224, -1000, -1000, -1000,  -235, -1000, -1000,  -255,
 -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000,  -248, -1000,  -261, -1000, -1000, -1000,
 -1000, -1000 };
int yypgo[]={

     0,    43,    54,    53,    52,    39,    29,    50,    49,    48,
    47,    46,    45,    40,    30 };
int yyr1[]={

     0,    12,    12,    13,    13,     1,     1,     1,     1,     2,
     3,     3,     4,     4,     4,     4,     5,    11,     6,     6,
     6,     6,     6,     6,     6,     6,     7,     8,    10,    10,
     9,     9,    14 };
int yyr2[]={

     0,     7,     1,     5,     1,     9,    11,     7,     3,     5,
     3,     3,     7,     3,     7,     3,     5,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     7,     7,     5,     3,
     5,     3,     1 };
int yychk[]={

 -1000,   -12,    -1,    -2,    -3,   273,   -14,   -13,   259,   271,
   266,    -1,    -4,   260,    -5,   256,   -11,   271,   260,   265,
    -6,   269,   268,   270,   267,    -7,    -8,    -1,   272,   261,
   263,   260,    -5,   256,   -10,   -14,    -9,   -14,   262,    -6,
   264,    -6 };
int yydef[]={

    -2,    -2,     4,     8,     0,    10,    11,    32,     0,     9,
     1,     3,     0,     7,    13,    15,    32,    17,     5,     0,
    16,    18,    19,    20,    21,    22,    23,    24,    25,    32,
    32,     6,    12,    14,    32,    29,    32,    31,    26,    28,
    27,    30 };
typedef struct { char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"IDLLPAREN",	257,
	"IDLRPAREN",	258,
	"IDLLBRACKET",	259,
	"IDLRBRACKET",	260,
	"IDLLBRACE",	261,
	"IDLRBRACE",	262,
	"IDLLESS",	263,
	"IDLGREATER",	264,
	"IDLSEMICOLON",	265,
	"IDLEND",	266,
	"IDLSTRING",	267,
	"IDLRATIONAL",	268,
	"IDLINTEGER",	269,
	"IDLBOOLEAN",	270,
	"IDLNAME",	271,
	"IDLLABELREF",	272,
	"IDLLABEL",	273,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"IDL_root : IDL_nodeDesc IDL_nodeDescSeq IDLEND",
	"IDL_root : /* empty */",
	"IDL_nodeDescSeq : IDL_nodeDescSeq IDL_nodeDesc",
	"IDL_nodeDescSeq : /* empty */",
	"IDL_nodeDesc : IDL_nodeName IDLLBRACKET IDL_attrseq IDLRBRACKET",
	"IDL_nodeDesc : IDL_nodeName IDLLBRACKET IDL_attrseq IDLSEMICOLON IDLRBRACKET",
	"IDL_nodeDesc : IDL_nodeName IDLLBRACKET IDLRBRACKET",
	"IDL_nodeDesc : IDL_nodeName",
	"IDL_nodeName : IDL_label IDLNAME",
	"IDL_label : IDLLABEL",
	"IDL_label : IDLNothing",
	"IDL_attrseq : IDL_attrseq IDLSEMICOLON IDL_attrDesc",
	"IDL_attrseq : IDL_attrDesc",
	"IDL_attrseq : IDL_attrseq IDLSEMICOLON error",
	"IDL_attrseq : error",
	"IDL_attrDesc : IDL_attrname IDL_IDLVALUE",
	"IDL_attrname : IDLNAME",
	"IDL_IDLVALUE : IDLINTEGER",
	"IDL_IDLVALUE : IDLRATIONAL",
	"IDL_IDLVALUE : IDLBOOLEAN",
	"IDL_IDLVALUE : IDLSTRING",
	"IDL_IDLVALUE : IDL_setDesc",
	"IDL_IDLVALUE : IDL_seqDesc",
	"IDL_IDLVALUE : IDL_nodeDesc",
	"IDL_IDLVALUE : IDLLABELREF",
	"IDL_setDesc : IDLLBRACE IDL_IDLVALUEset IDLRBRACE",
	"IDL_seqDesc : IDLLESS IDL_IDLVALUEseq IDLGREATER",
	"IDL_IDLVALUEset : IDL_IDLVALUEset IDL_IDLVALUE",
	"IDL_IDLVALUEset : IDLNothing",
	"IDL_IDLVALUEseq : IDL_IDLVALUEseq IDL_IDLVALUE",
	"IDL_IDLVALUEseq : IDLNothing",
	"IDLNothing : /* empty */",
};
#endif /* YYDEBUG */
#line 1 "/usr/lib/yaccpar"
/*	@(#)yaccpar 1.10 89/04/04 SMI; from S5R3 1.10	*/

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	{ free(yys); free(yyv); return(0); }
#define YYABORT		{ free(yys); free(yyv); return(1); }
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-1000)

/*
** static variables used by the parser
*/
static YYSTYPE *yyv;			/* value stack */
static int *yys;			/* state stack */

static YYSTYPE *yypv;			/* top of value stack */
static int *yyps;			/* top of state stack */

static int yystate;			/* current state */
static int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */

int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */


/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
int
yyparse()
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */
	unsigned yymaxdepth = YYMAXDEPTH;

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yyv = (YYSTYPE*)malloc(yymaxdepth*sizeof(YYSTYPE));
	yys = (int*)malloc(yymaxdepth*sizeof(int));
	if (!yyv || !yys)
	{
		yyerror( "out of memory" );
		return(1);
	}
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

	goto yystack;
	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			(void)printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				(void)printf( "end-of-file\n" );
			else if ( yychar < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				(void)printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			int yyps_index = (yy_ps - yys);
			int yypv_index = (yy_pv - yyv);
			int yypvt_index = (yypvt - yyv);
			yymaxdepth += YYMAXDEPTH;
			yyv = (YYSTYPE*)realloc((char*)yyv,
				yymaxdepth * sizeof(YYSTYPE));
			yys = (int*)realloc((char*)yys,
				yymaxdepth * sizeof(int));
			if (!yyv || !yys)
			{
				yyerror( "yacc stack overflow" );
				return(1);
			}
			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			(void)printf( "Received token " );
			if ( yychar == 0 )
				(void)printf( "end-of-file\n" );
			else if ( yychar < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				(void)printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				(void)printf( "Received token " );
				if ( yychar == 0 )
					(void)printf( "end-of-file\n" );
				else if ( yychar < 0 )
					(void)printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					(void)printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
				yynerrs++;
			skip_init:
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						(void)printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					(void)printf( "Error recovery discards " );
					if ( yychar == 0 )
						(void)printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						(void)printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						(void)printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			(void)printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 1:
# line 83 "parse.y"
{
				 IDLReduce("IDL_root");
				 IDLroot_node = yypvt[-2].VnodeDesc;
				 /* match all references to the node */
				 IDLmatch_references();
				 YYACCEPT;
				} break;
case 2:
# line 91 "parse.y"
{
				 IDLReduce("_root");
				 IDLroot_node = NULL;
				 YYACCEPT;
				} break;
case 3:
# line 99 "parse.y"
{
				 IDLReduce("IDL_nodeDescSeq");
				} break;
case 4:
# line 103 "parse.y"
{
				 IDLReduce("IDL_nodeDescSeq");
				} break;
case 5:
# line 109 "parse.y"
{
				 IDLReduce("IDL_nodeDesc");
				 yyval.VnodeDesc = yypvt[-3].VnodeDesc;
				 yyval.VnodeDesc->attributes = yypvt[-1].VSEQattrDesc;
				} break;
case 6:
# line 115 "parse.y"
{
				 IDLReduce("IDL_nodeDesc");
				 yyval.VnodeDesc = yypvt[-4].VnodeDesc;
				 yyval.VnodeDesc->attributes = yypvt[-2].VSEQattrDesc;
				} break;
case 7:
# line 121 "parse.y"
{
				 IDLReduce("IDL_nodeDesc");
				 yyval.VnodeDesc = yypvt[-2].VnodeDesc;
				} break;
case 8:
# line 126 "parse.y"
{
				 IDLReduce("IDL_nodeDesc");
				 yyval.VnodeDesc = yypvt[-0].VnodeDesc;
				} break;
case 9:
# line 133 "parse.y"
{
				 IDLReduce("IDL_nodeName");
				 yyval.VnodeDesc = NnodeDesc;
				 yyval.VnodeDesc->srcpos = IDLLINECHARPOS(IDLlineNumber,IDLCharPos-strlen (yypvt[-0].name)+1);
				 yyval.VnodeDesc->label = yypvt[-1].name;
				 yyval.VnodeDesc->name = yypvt[-0].name;
				 if (strlen(yypvt[-1].name) > 0) /* has label */
					IDLinsert_hashtable(yyval.VnodeDesc);
				} break;
case 10:
# line 145 "parse.y"
{
				 IDLReduce("IDL_label");
				 yyval.name = yypvt[-0].name;
				} break;
case 11:
# line 150 "parse.y"
{
				 IDLReduce("IDL_label");
				 yyval.name = NewString("\0");
				} break;
case 12:
# line 156 "parse.y"
{
				 IDLReduce("IDL_attrseq");
				 appendrearSEQattrDesc(yypvt[-2].VSEQattrDesc, yypvt[-0].VattrDesc);
				 yyval.VSEQattrDesc = yypvt[-2].VSEQattrDesc;
				} break;
case 13:
# line 162 "parse.y"
{
				 IDLReduce("IDL_attrseq");
				 initializeSEQattrDesc(yyval.VSEQattrDesc);
				 appendfrontSEQattrDesc(yyval.VSEQattrDesc, yypvt[-0].VattrDesc);
				} break;
case 14:
# line 168 "parse.y"
{
				 IDLReduce("IDL_attrseq");
				 yyval.VSEQattrDesc = yypvt[-2].VSEQattrDesc;
				} break;
case 15:
# line 173 "parse.y"
{
				 IDLReduce("IDL_attrseq");
				 initializeSEQattrDesc(yyval.VSEQattrDesc);
				} break;
case 16:
# line 179 "parse.y"
{
				 IDLReduce("IDL_attrDesc");
				 yyval.VattrDesc = NattrDesc;
 			         yyval.VattrDesc->srcpos = IDLLINECHARPOS(yypvt[-1].attr_name_type->linenumber,yypvt[-1].attr_name_type->charpos);
				 yyval.VattrDesc->name = yypvt[-1].attr_name_type->name;
				 if (yypvt[-0].VIDLVALUE.isname) { /* store name in a stringDesc */
				     stringDesc AstringDesc;

				     AstringDesc = NstringDesc;
				     AstringDesc->value = yypvt[-0].VIDLVALUE.value.name;
				     yyval.VattrDesc->value.VstringDesc = AstringDesc;
				     appendrearSEQattrDesc(IDLattrlabelrefs, yyval.VattrDesc);
				   }
				 else yyval.VattrDesc->value = yypvt[-0].VIDLVALUE.value.value;
				} break;
case 17:
# line 196 "parse.y"
{
				 IDLReduce("IDL_attrname");
				 yyval.attr_name_type = (IDLATTR_NAME *)malloc((unsigned)sizeof (IDLATTR_NAME));
				 yyval.attr_name_type->name = yypvt[-0].name;
				 yyval.attr_name_type->linenumber = IDLlineNumber;		
				 yyval.attr_name_type->charpos = IDLCharPos - strlen (yypvt[-0].name) + 1;
				} break;
case 18:
# line 205 "parse.y"
{
				 IDLReduce("IDL_IDLVALUE");
				 yyval.VIDLVALUE.isname = FALSE;
				 yyval.VIDLVALUE.value.value.VintegerDesc = yypvt[-0].intval;
				} break;
case 19:
# line 211 "parse.y"
{
				 IDLReduce("IDL_IDLVALUE");
				 yyval.VIDLVALUE.isname = FALSE;
				 yyval.VIDLVALUE.value.value.VrationalDesc = yypvt[-0].ratval;
				} break;
case 20:
# line 217 "parse.y"
{
				 IDLReduce("IDL_IDLVALUE");
				 yyval.VIDLVALUE.isname = FALSE;
				 yyval.VIDLVALUE.value.value.VbooleanDesc = yypvt[-0].boolval;
				} break;
case 21:
# line 223 "parse.y"
{
				 IDLReduce("IDL_IDLVALUE");
				 yyval.VIDLVALUE.isname = FALSE;
				 yyval.VIDLVALUE.value.value.VstringDesc = yypvt[-0].strval;
				} break;
case 22:
# line 229 "parse.y"
{
				 IDLReduce("IDL_IDLVALUE");
				 yyval.VIDLVALUE.isname = FALSE;
				 yyval.VIDLVALUE.value.value.VsetDesc = yypvt[-0].VsetDesc;
				} break;
case 23:
# line 235 "parse.y"
{
				 IDLReduce("IDL_IDLVALUE");
				 yyval.VIDLVALUE.isname = FALSE;
				 yyval.VIDLVALUE.value.value.VsequenceDesc = yypvt[-0].VsequenceDesc;
				} break;
case 24:
# line 241 "parse.y"
{
				 IDLReduce("IDL_IDLVALUE");
				 yyval.VIDLVALUE.isname = FALSE;
				 yyval.VIDLVALUE.value.value.VnodeDesc = yypvt[-0].VnodeDesc;
				} break;
case 25:
# line 247 "parse.y"
{ 
				 IDLReduce("IDL_IDLVALUE");
				 yyval.VIDLVALUE.isname = TRUE;
				 yyval.VIDLVALUE.value.name = yypvt[-0].name;
				} break;
case 26:
# line 255 "parse.y"
{
				 IDLReduce("IDL_setDesc");
				 yyval.VsetDesc = NsetDesc;
				 yyval.VsetDesc->value = yypvt[-1].VSEQIDLVALUE;
				 {SEQIDLVALUE Si;
				  IDLVALUE Ai;
				  foreachinSEQIDLVALUE(yypvt[-1].VSEQIDLVALUE, Si, Ai) 
				    if (typeof(Ai)==KnodeDesc) {
				      if (Ai.VnodeDesc->name == IDLref_indicator_name) {
					IDLanIDLVALUE.VsetDesc = yyval.VsetDesc;
					appendrearSEQIDLVALUE(IDLsetlabelrefs, IDLanIDLVALUE);
					break;
				      }
				    }
				 }
				} break;
case 27:
# line 274 "parse.y"
{
				 IDLReduce("IDL_seqDesc");
				 yyval.VsequenceDesc = NsequenceDesc;
				 yyval.VsequenceDesc->value = yypvt[-1].VSEQIDLVALUE;
				 {SEQIDLVALUE Si;
				  IDLVALUE Ai;
				  foreachinSEQIDLVALUE(yypvt[-1].VSEQIDLVALUE, Si, Ai) 
				    if (typeof(Ai)==KnodeDesc) {
				      if (Ai.VnodeDesc->name == IDLref_indicator_name) {
					IDLanIDLVALUE.VsequenceDesc = yyval.VsequenceDesc;
					appendfrontSEQIDLVALUE(IDLseqlabelrefs, IDLanIDLVALUE);
					break;
				      }
				    }
				}
				} break;
case 28:
# line 293 "parse.y"
{
				 IDLReduce("IDL_IDLVALUEset");
				 if (yypvt[-0].VIDLVALUE.isname) {
				   IDLanodeDesc = NnodeDesc;
				   IDLanodeDesc->name = IDLref_indicator_name;
				   IDLanodeDesc->label = yypvt[-0].VIDLVALUE.value.name;
				   IDLanIDLVALUE.VnodeDesc = IDLanodeDesc;
				   appendrearSEQIDLVALUE(yypvt[-1].VSEQIDLVALUE,IDLanIDLVALUE);
				 }
				 else appendrearSEQIDLVALUE(yypvt[-1].VSEQIDLVALUE, yypvt[-0].VIDLVALUE.value.value);
				 yyval.VSEQIDLVALUE = yypvt[-1].VSEQIDLVALUE;
				} break;
case 29:
# line 306 "parse.y"
{
				 IDLReduce("IDL_IDLVALUEset");
				 initializeSEQIDLVALUE(yyval.VSEQIDLVALUE);
				} break;
case 30:
# line 313 "parse.y"
{
				 IDLReduce("IDL_IDLVALUEseq");
				 if (yypvt[-0].VIDLVALUE.isname) {
				   IDLanodeDesc = NnodeDesc;
				   IDLanodeDesc->name = IDLref_indicator_name;
				   IDLanodeDesc->label = yypvt[-0].VIDLVALUE.value.name;
				   IDLanIDLVALUE.VnodeDesc = IDLanodeDesc;
				   appendrearSEQIDLVALUE(yypvt[-1].VSEQIDLVALUE,IDLanIDLVALUE);
				 }
                                 else appendrearSEQIDLVALUE(yypvt[-1].VSEQIDLVALUE, yypvt[-0].VIDLVALUE.value.value);
				 yyval.VSEQIDLVALUE = yypvt[-1].VSEQIDLVALUE;
				} break;
case 31:
# line 326 "parse.y"
{
				 IDLReduce("IDL_IDLVALUEseq");
				 initializeSEQIDLVALUE(yyval.VSEQIDLVALUE);
				} break;
case 32:
# line 333 "parse.y"
{
				 IDLReduce("IDL_Nothing");
				} break;
	}
	goto yystack;		/* reset registers in driver code */
}
